local addonName, addonTab = ... --[[ Using addonName, addonTab here in the Init file for ubiquity ]]
addonTab.version = GetAddOnMetadata(addonName, "Version")

--{ SavedVariables' Defaults }--
addonTab.defaults = {}

--{ SavedVariables Loader }--
addonTab.loader = CreateFrame("Frame")
addonTab.loader:RegisterEvent("ADDON_LOADED") --{ Payload: addOnName, containsBindings

addonTab.loader:SetScript("OnEvent", function(self, event, ...)
	if (event == "ADDON_LOADED") then
		self[event](self, ...)
	end
end)

function addonTab.loader:ADDON_LOADED(addonName)
	local function initDB(db, defaults)
		if type(db) ~= "table" then db = {} end
		if type(defaults) ~= "table" then return db end
		for k, v in pairs(defaults) do
			if type(v) == "table" then
				db[k] = initDB(db[k], v)
			elseif type(v) ~= type(db[k]) then
				db[k] = v
			end
		end
		return db
	end
	--{ Account SavedVariables }--
	_G[addonName.."_DB"] = initDB(_G[addonName.."_DB"], addonTab.defaults)
	addonTab.db = _G[addonName.."_DB"]
	
	--{ Character SavedVariables }--
	_G[addonName.."_PC"] = initDB(_G[addonName.."_PC"], addonTab.defaults)
	addonTab.pc = _G[addonName.."_PC"]

	self:UnregisterEvent("ADDON_LOADED")
end

--{ Slash Commands }--